VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CSocketWrapper"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private objParent As CSocketArray
Public WithEvents Socket As CSocket
Attribute Socket.VB_VarHelpID = -1
Public WithEvents Connection As ADODB.Connection
Attribute Connection.VB_VarHelpID = -1
Public FreezeEvents As Boolean
Public FreezeSocketEvents As Boolean
Public FreezeConnectionEvents As Boolean

Public Enum ClientStates
  StateDisconnected          '
  StateDisconnecting         '
  StateConnecting            '
  StateConnectedWait         ',  
  StateConnectedWork         ', , 
  StateConnectedIdle         ', , 
End Enum

Public Online As Boolean
Public State As ClientStates
Public SessionKey As String
Public ConnectDate As Date
Public Client As String
Public ClientName As String
Public SessionDate As Date
Public CardID As Long
Public CardCode As String
Public Traffic As Currency
Public Balance As Currency
Public Warned As Boolean
Public Buffer As String
Public Data As String
Public ClosePending As Boolean
Public CloseReason As String
Public QueryPending As Boolean
Public QueryCommand As String
Public QueryArguments As Variant

Public Sub SetState(ByVal NewState As ClientStates)
Select Case NewState
  Case ClientStates.StateDisconnected
    Online = False
    SessionKey = vbNullString
    ConnectDate = vbEmptyDate
    Client = vbNullString
    ClientName = vbNullString
    SessionDate = vbEmptyDate
    CardID = 0&
    CardCode = vbNullString
    Traffic = 0@
    Balance = 0@
    Warned = False
    ClosePending = False
    CloseReason = vbNullString
    QueryPending = False
    QueryCommand = vbNullString
    QueryArguments = Empty
  Case ClientStates.StateDisconnecting
    Online = False
    ConnectDate = vbEmptyDate
    SessionDate = vbEmptyDate
    CardID = 0&
    CardCode = vbNullString
    Traffic = 0@
    Balance = 0@
    Warned = False
    QueryPending = False
    QueryCommand = vbNullString
    QueryArguments = Empty
  Case ClientStates.StateConnecting
    Online = False
    ConnectDate = ServerDate()
    SessionDate = vbEmptyDate
    CardID = 0&
    CardCode = vbNullString
    Traffic = 0@
    Balance = 0@
    Warned = False
  Case ClientStates.StateConnectedWait
    Online = False
    SessionDate = vbEmptyDate
    CardID = 0&
    CardCode = vbNullString
    Traffic = 0@
    Balance = 0@
    Warned = False
  Case ClientStates.StateConnectedWork
    Online = True
  Case ClientStates.StateConnectedIdle
    Online = True
End Select
State = NewState
End Sub

Public Sub Create(Parent As CSocketArray, Optional PassSocket As CSocket, Optional PassConnection As ADODB.Connection)
Set objParent = Parent
Set Connection = PassConnection
If PassSocket Is Nothing Then
  Set Socket = New CSocket
Else
  Set Socket = PassSocket
End If
End Sub

Public Sub Dispose()
Set Connection = Nothing
Set Socket = Nothing
Set objParent = Nothing
End Sub

Private Sub Connection_BeginTransComplete(ByVal TransactionLevel As Long, ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pConnection As ADODB.Connection)
If Not FreezeEvents And Not FreezeConnectionEvents Then objParent.GenerateConnectionBeginTransComplete Me, TransactionLevel, pError, adStatus, pConnection
End Sub

Private Sub Connection_CommitTransComplete(ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pConnection As ADODB.Connection)
If Not FreezeEvents And Not FreezeConnectionEvents Then objParent.GenerateConnectionCommitTransComplete Me, pError, adStatus, pConnection
End Sub

Private Sub Connection_ConnectComplete(ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pConnection As ADODB.Connection)
If Not FreezeEvents And Not FreezeConnectionEvents Then objParent.GenerateConnectionConnectComplete Me, pError, adStatus, pConnection
End Sub

Private Sub Connection_Disconnect(adStatus As ADODB.EventStatusEnum, ByVal pConnection As ADODB.Connection)
If Not FreezeEvents And Not FreezeConnectionEvents Then objParent.GenerateConnectionDisconnect Me, adStatus, pConnection
End Sub

Private Sub Connection_ExecuteComplete(ByVal RecordsAffected As Long, ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pCommand As ADODB.Command, ByVal pRecordset As ADODB.Recordset, ByVal pConnection As ADODB.Connection)
If Not FreezeEvents And Not FreezeConnectionEvents Then objParent.GenerateConnectionExecuteComplete Me, RecordsAffected, pError, adStatus, pCommand, pRecordset, pConnection
End Sub

Private Sub Connection_InfoMessage(ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pConnection As ADODB.Connection)
If Not FreezeEvents And Not FreezeConnectionEvents Then objParent.GenerateConnectionInfoMessage Me, pError, adStatus, pConnection
End Sub

Private Sub Connection_RollbackTransComplete(ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pConnection As ADODB.Connection)
If Not FreezeEvents And Not FreezeConnectionEvents Then objParent.GenerateConnectionRollbackTransComplete Me, pError, adStatus, pConnection
End Sub

Private Sub Connection_WillConnect(ConnectionString As String, UserID As String, Password As String, Options As Long, adStatus As ADODB.EventStatusEnum, ByVal pConnection As ADODB.Connection)
If Not FreezeEvents And Not FreezeConnectionEvents Then objParent.GenerateConnectionWillConnect Me, ConnectionString, UserID, Password, Options, adStatus, pConnection
End Sub

Private Sub Connection_WillExecute(Source As String, CursorType As ADODB.CursorTypeEnum, LockType As ADODB.LockTypeEnum, Options As Long, adStatus As ADODB.EventStatusEnum, ByVal pCommand As ADODB.Command, ByVal pRecordset As ADODB.Recordset, ByVal pConnection As ADODB.Connection)
If Not FreezeEvents And Not FreezeConnectionEvents Then objParent.GenerateConnectionWillExecute Me, Source, CursorType, LockType, Options, adStatus, pCommand, pRecordset, pConnection
End Sub

Private Sub Socket_OnClose()
If Not FreezeEvents And Not FreezeSocketEvents Then objParent.GenerateSocketClose Me
End Sub

Private Sub Socket_OnConnect()
If Not FreezeEvents And Not FreezeSocketEvents Then objParent.GenerateSocketConnect Me
End Sub

Private Sub Socket_OnConnectionRequest(ByVal requestID As Long)
If Not FreezeEvents And Not FreezeSocketEvents Then objParent.GenerateSocketConnectionRequest Me, requestID
End Sub

Private Sub Socket_OnDataArrival(ByVal bytesTotal As Long)
If Not FreezeEvents And Not FreezeSocketEvents Then objParent.GenerateSocketDataArrival Me, bytesTotal
End Sub

Private Sub Socket_OnError(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
If Not FreezeEvents And Not FreezeSocketEvents Then objParent.GenerateSocketError Me, Number, Description, Scode, Source, HelpFile, HelpContext, CancelDisplay
End Sub

Private Sub Socket_OnSendComplete()
If Not FreezeEvents And Not FreezeSocketEvents Then objParent.GenerateSocketSendComplete Me
End Sub

Private Sub Socket_OnSendProgress(ByVal bytesSent As Long, ByVal bytesRemaining As Long)
If Not FreezeEvents And Not FreezeSocketEvents Then objParent.GenerateSocketSendProgress Me, bytesSent, bytesRemaining
End Sub
